%%
	PIC16C/F84 copy machine Ver.3     By Ikushima Yasuo
%%

% include -------------------------------------------------
#include pic16c64.def

#cnf	2007	11111111110001	;XT X'tal, WDT=non, PWT=non, CP=non

% command def ---------------------------------------------
#def LCREG   00000000b ;Load Configuration
#def LDPM    00000010b ;Load Data for Prog. Mem.
#def RDPM    00000100b ;Read Data for Prog. Mem.
#def INCAD   00000110b ;INCrement  ADdress
#def BEGINP  00001000b ;BEGIN Programing
#def LDDM    00000011b ;Load Data from Data Memory
#def RDDM    00000101b ;Read Data from Data Memory

% port def ------------------------------------------------
#def LedDrvA portc
#def LedDrvB portd
#def DataI/O portb

% bitdef --------------------------------------------------
#bitdef Led1G LedDrvA  0
#bitdef Led1R LedDrvA  1
#bitdef Led2G LedDrvA  2
#bitdef Led2R LedDrvA  3
#bitdef Led3G LedDrvB  0
#bitdef Led3R LedDrvB  1
#bitdef Led4G LedDrvB  2
#bitdef Led4R LedDrvB  3
#bitdef Led5G LedDrvA  4
#bitdef Led5R LedDrvA  5
#bitdef Led6G LedDrvA  6
#bitdef Led6R LedDrvA  7
#bitdef Led7G LedDrvB  4
#bitdef Led7R LedDrvB  5
#bitdef Led8G LedDrvB  6
#bitdef Led8R LedDrvB  7

#bitdef TPic1Data DataI/O  7
#bitdef TPic2Data DataI/O  6
#bitdef TPic3Data DataI/O  5
#bitdef TPic4Data DataI/O  4
#bitdef TPic5Data DataI/O  3
#bitdef TPic6Data DataI/O  2
#bitdef TPic7Data DataI/O  1
#bitdef TPic8Data DataI/O  0

#bitdef TPicClock porta  0
#bitdef MTPicVpp  porta  1
#bitdef MPicData  porta  2
#bitdef MPicClock porta  3
#bitdef ModeSw1   porta  4
#bitdef ModeSw2   porta  5

#bitdef TxD       porte  0
#bitdef RxD       porte  1
#bitdef Led11     porte  2

% prog. mem. top ------------------------------------------
#org 0x00
goto init

% main mode jump table ------------------------------------
#lbl mmjmp
pcl += mmode
goto mmode00  ;00 Mode sw read
goto mmode01  ;01 Vpp off -> on 
goto mmode02  ;02 Adr. Init. Terget PIC Erase. 
goto mmode03  ;03 Prog. Data Read from Master PIC 
goto mmode04  ;04 Prog. Data Write to Terget PIC
goto mmode05  ;05 Prog. Data Read from Terget PIC 
goto mmode06  ;06 Cmp. Data.
goto mmode07  ;07 Write Error 
goto mmode08  ;08 Prog. Adr. check
goto mmode09  ;09 Adr. Inc. 
goto mmode01  ;0A Vpp off -> on 
goto mmode0B  ;0B Data. ROM Init. 
goto mmode0C  ;0C Data ROM Data Read from Master PIC
goto mmode0D  ;0D Data ROM Data Write to Terget PIC 
goto mmode0E  ;0E Data ROM Data Read from Terget PIC
goto mmode06  ;0F Cmp. Data.
goto mmode07  ;10 Write Error 
goto mmode11  ;11 Data Adr. check 
goto mmode09  ;12 Adr. Inc. 
goto mmode01  ;13 Vpp off -> on 
goto mmode14  ;14 Config ROM Init.
goto mmode03  ;15 Config Data Read from Master PIC
goto mmode04  ;16 Config Data Write to Terget PIC 
goto mmode05  ;17 Config Data Read from Terget PIC
goto mmode06  ;18 Cmp. Data.
goto mmode07  ;19 Write Error 
goto mmode09  ;1A Adr. Inc. 
goto mmode03  ;1B Config Data Read from Master PIC
goto mmode04  ;1C Config Data Write to Terget PIC 
goto mmode05  ;1D Config Data Read from Terget PIC
goto mmode06  ;1E Cmp. Data.
goto mmode07  ;1F Write Error 
goto mmode09  ;20 Adr. Inc. 
goto mmode03  ;21 Config Data Read from Master PIC
goto mmode04  ;22 Config Data Write to Terget PIC 
goto mmode05  ;23 Config Data Read from Terget PIC
goto mmode06  ;24 Cmp. Data.
goto mmode07  ;25 Write Error 
goto mmode09  ;26 Adr. Inc. 
goto mmode03  ;27 Config Data Read from Master PIC
goto mmode04  ;28 Config Data Write to Terget PIC 
goto mmode05  ;29 Config Data Read from Terget PIC
goto mmode06  ;2A Cmp. Data.
goto mmode07  ;2B Write Error 
goto mmode09  ;2C Adr. Inc. 
goto mmode09  ;2D Adr. Inc. 
goto mmode09  ;2E Adr. Inc. 
goto mmode09  ;2F Adr. Inc. 
goto mmode03  ;30 Config Data Read from Master PIC
goto mmode31  ;31 Config Data Write to Terget PIC 
goto mmode05  ;32 Config Data Read from Terget PIC
goto mmode06  ;33 Cmp. Data.
goto mmode07  ;34 Write Error 
goto mmode01  ;35 Vpp off -> on 
goto mmode36  ;36 Adr. Init. etc. 
goto mmode03  ;37 Prog. Data Read from Master PIC 
goto mmode05  ;38 Prog. Data Read from Terget PIC 
goto mmode06  ;39 Cmp. Data.
goto mmode07  ;3A Write Error 
goto mmode3B  ;3B Prog. Adr. check
goto mmode09  ;3C Adr. Inc. 
goto mmode01  ;3D Vpp off -> on 
goto mmode0B  ;3E Data. ROM Init. 
goto mmode0C  ;3F Data ROM Data Read from Master PIC
goto mmode0E  ;40 Data ROM Data Read from Terget PIC
goto mmode06  ;41 Cmp. Data.
goto mmode07  ;42 Write Error 
goto mmode43  ;43 Data Adr. check 
goto mmode09  ;44 Adr. Inc. 
goto mmode01  ;45 Vpp off -> on 
goto mmode14  ;46 Config ROM Init.
goto mmode03  ;47 Config Data Read from Master PIC
goto mmode05  ;48 Config Data Read from Terget PIC
goto mmode06  ;49 Cmp. Data.
goto mmode07  ;4A Write Error 
goto mmode09  ;4B Adr. Inc. 
goto mmode03  ;4C Config Data Read from Master PIC
goto mmode05  ;4D Config Data Read from Terget PIC
goto mmode06  ;4E Cmp. Data.
goto mmode07  ;4F Write Error 
goto mmode09  ;50 Adr. Inc. 
goto mmode03  ;51 Config Data Read from Master PIC
goto mmode05  ;52 Config Data Read from Terget PIC
goto mmode06  ;53 Cmp. Data.
goto mmode07  ;54 Write Error 
goto mmode09  ;55 Adr. Inc. 
goto mmode03  ;56 Config Data Read from Master PIC
goto mmode05  ;57 Config Data Read from Terget PIC
goto mmode06  ;58 Cmp. Data.
goto mmode07  ;59 Write Error 
goto mmode09  ;5A Adr. Inc. 
goto mmode09  ;5B Adr. Inc. 
goto mmode09  ;5C Adr. Inc. 
goto mmode09  ;5D Adr. Inc. 
goto mmode03  ;5E Config Data Read from Master PIC
goto mmode05  ;5F Config Data Read from Terget PIC
goto mmode06  ;60 Cmp. Data.
goto mmode07  ;61 Write Error 
goto mmode62  ;62 Write Protect
goto mmode63  ;63 Vpp off

% init ----------------------------------------------------
init:

% port in/out select --------------------------------------
page( #1 )
trisa =  #11110000b
trisb =  #00000000b
trisc =  #00000000b
trisd =  #00000000b
trise.2 = #0
page( #0 )

option.rbpu = #0
porta = #0
portb = #0
portc = #0
portd = #0
porte.2 = #0

% ram init ------------------------------------------------
mmode = #0
tmp0 = #0
ErrorReg = #0

 call Wait10msec
 call Wait10msec

% main loop -----------------------------------------------
#lbl main

 goto mmjmp

#lbl mmode00  ;00 Mode sw read ----------------------------
; Orang 
 Led1G = #1 
 Led2G = #1 
 Led3G = #1 
 Led4G = #1 
 Led5G = #1 
 Led6G = #1 
 Led7G = #1 
 Led8G = #1 
 Led1R = #1 
 Led2R = #1 
 Led3R = #1 
 Led4R = #1 
 Led5R = #1 
 Led6R = #1 
 Led7R = #1 
 Led8R = #1 

#char tmp0
#bitdef WProtectMode tmp0  0
#bitdef CompOnly     tmp0  1
#def SwOn 0
#def Yes  1

 if(ModeSw1 == #SwOn) WProtectMode =  #Yes
 if(ModeSw2 == #SwOn) CompOnly =  #Yes
 if(CompOnly == #Yes) {

#char  mmode
#def CompMode 0x35
  mmode =  #CompMode
  goto Mend 
 }
 goto MendInc 

#lbl mmode01  ;01 Vpp off -> on ---------------------------
#def VppON  11110010b
#def VppOFF 11110000b
 porta = #VppOFF
 nop
 nop
 nop
 porta = #VppON
 goto  MendInc

#lbl mmode02  ;02 Adr. Init. etc. -------------------------
 if(CompOnly ==#No) call TPicErace

#lbl mmode36  ;36 Adr. Init. etc. -------------------------

  if (mmode == #0x36) Led11 = #1

#int  AdrReg
 AdrReg = #0
#int   sword
 sword =  #0  ;dummy data 
 W = #LDPM    ;Load data for prog. mem. 
 call Msdata
 W = #LDPM    ;Load data for prog. mem. 
 call Tsdata
 goto MendInc 

#lbl mmode03  ;03 Prog. Data Read from Master PIC ---------
#int mrword 
#def PmemLoop 0x03
 W = #RDPM    ;Read data from prog. mem.
 call Mrdata
 goto MendInc 

#lbl mmode04  ;04 Prog. Data Write to Terget PIC ----------
 mrword &= #0111111111111110b
 sword = mrword 
 W = #LDPM    ;Load data for prog. mem. 
 call Tsdata
 call BeginProg 
 call Wait10msec
 goto MendInc 

#lbl mmode05  ;05 Prog. Data Read from Terget PIC ---------
 W = #RDPM    ;Read data from prog. mem.
 call Trdata
 goto  MendInc

#lbl mmode06  ;06 Cmp. Data.-------------------------------
#int trword1
#int trword2
#int trword3
#int trword4
#int trword5
#int trword6
#int trword7
#int trword8
#char ErrorReg
#char ErrorRegOld 
 mrword &= #0111111111111110b
 trword1 &= #0111111111111110b
 trword2 &= #0111111111111110b
 trword3 &= #0111111111111110b
 trword4 &= #0111111111111110b
 trword5 &= #0111111111111110b
 trword6 &= #0111111111111110b
 trword7 &= #0111111111111110b
 trword8 &= #0111111111111110b
 ErrorRegOld = ErrorReg 
 if (trword1 != mrword) ErrorReg.0 =  #1
 if (trword2 != mrword) ErrorReg.1 =  #1
 if (trword3 != mrword) ErrorReg.2 =  #1
 if (trword4 != mrword) ErrorReg.3 =  #1
 if (trword5 != mrword) ErrorReg.4 =  #1
 if (trword6 != mrword) ErrorReg.5 =  #1
 if (trword7 != mrword) ErrorReg.6 =  #1
 if (trword8 != mrword) ErrorReg.7 =  #1
 goto  MendInc

#lbl mmode07  ;07 Write Error -----------------------------
 if (ErrorReg != ErrorRegOld) {
  if (ErrorReg.0 == #1) {
   Led1G = #0 
   Led1R = #1 
  }
  if (ErrorReg.1 == #1) {
   Led2G = #0 
   Led2R = #1 
  }
  if (ErrorReg.2 == #1) {
   Led3G = #0 
   Led3R = #1 
  }
  if (ErrorReg.3 == #1) {
   Led4G = #0 
   Led4R = #1 
  }
  if (ErrorReg.4 == #1) {
   Led5G = #0 
   Led5R = #1 
  }
  if (ErrorReg.5 == #1) {
   Led6G = #0 
   Led6R = #1 
  }
  if (ErrorReg.6 == #1) {
   Led7G = #0 
   Led7R = #1 
  }
  if (ErrorReg.7 == #1) {
   Led8G = #0 
   Led8R = #1 
  }
 }
 goto MendInc 

#lbl mmode08  ;08 Prog. Adr. check ------------------------
#def LastProgAdr 0x3FF
 if (AdrReg == #LastProgAdr) {
  mmode ++
  goto MendInc 
 }
 AdrReg += #1 
 call IncAdr
 mmode = #PmemLoop
 goto Mend

#lbl mmode09  ;09 Adr. Inc. -------------------------------
 call IncAdr
 goto MendInc 

#lbl mmode0B  ;0B Data. ROM Init. -------------------------
 AdrReg = #0
 sword =  #0  ;dummy data 
 W = #LDDM    ;Load Data for Data Memory
 call Msdata
 W = #LDDM    ;Load Data for Data Memory
 call Tsdata
 goto MendInc 

#lbl mmode0C  ;0C Data ROM Data Read from Master PIC ------
#def DmemLoop 0x0C
 W = #RDDM    ;Read data from Data Memory 
 call Mrdata
 goto MendInc 

#lbl mmode0D  ;0D Data ROM Data Write to Terget PIC -------
 mrword &= #0111111111111110b
 sword = mrword 
 W = #LDDM    ;Load data for Data Memory
 call Tsdata
 call BeginProg 
 call Wait10msec
 goto MendInc 

#lbl mmode0E  ;0E Data ROM Data Read from Terget PIC ------
 W = #RDDM    ;Read data from Data Memory 
 call Trdata
 goto MendInc 

#lbl mmode11  ;11 Data Adr. check -------------------------
#def LastDataAdr 0x03F
 if (AdrReg == #LastDataAdr) {
  mmode ++
  goto MendInc 
 }
 AdrReg += #1 
 call IncAdr
 mmode = #DmemLoop
 goto Mend

#lbl mmode14  ;14 Config ROM Init. ------------------------
 sword =  #0  ;dummy data 
 W = #LCREG   ;Load Configuration 
 call Msdata
 W = #LCREG   ;Load Configuration 
 call Tsdata
 goto MendInc 

#lbl mmode31  ;31 Config Data Write to Terget PIC ---------
 if(ModeSw1 == #SwOn) WProtectMode =  #Yes

 mrword &= #0111111111111110b
 sword = mrword 
 W = #LDPM    ;Load data for prog. mem. 
 call Tsdata
 call BeginProg 
 call Wait10msec
 goto MendInc

#lbl mmode3B  ;3B Prog. Adr. check ------------------------
 if (AdrReg == #LastProgAdr) goto MendInc 
 AdrReg += #1 
 mmode = #0x37
 goto Mend

#lbl mmode43  ;43 Data Adr. check -------------------------
 if (AdrReg == #LastDataAdr) {
  mmode ++
  goto MendInc 
 }
 AdrReg += #1 
 mmode = #0x3F
 call IncAdr
 goto Mend

#lbl mmode62  ;Write Protect ------------------------------
#def No 0
 if((WProtectMode == #No) || (CompOnly == #Yes)) goto MendInc

 sword = mrword 
 sword &= #0111111111011110b
 W = #LDPM    ;Load data for prog. mem. 
 call Tsdata
 call BeginProg 
 call Wait10msec
 goto MendInc

#lbl mmode63  ;Vpp off ------------------------------------
 porta = #VppOFF

 if (ErrorReg.0 == #0) {
  Led1G = #1 
  Led1R = #0 
 }
 if (ErrorReg.1 == #0) {
  Led2G = #1 
  Led2R = #0 
 }
 if (ErrorReg.2 == #0) {
  Led3G = #1 
  Led3R = #0 
 }
 if (ErrorReg.3 == #0) {
  Led4G = #1 
  Led4R = #0 
 }
 if (ErrorReg.4 == #0) {
  Led5G = #1 
  Led5R = #0 
 }
 if (ErrorReg.5 == #0) {
  Led6G = #1 
  Led6R = #0 
 }
 if (ErrorReg.6 == #0) {
  Led7G = #1 
  Led7R = #0 
 }
 if (ErrorReg.7 == #0) {
  Led8G = #1 
  Led8R = #0 
 }

#lbl 0
 goto 0b

#lbl MendInc
 mmode ++
#lbl Mend
 goto main

#lbl Msdata  ;---------------------------------------------
#char tmp

 call MsSendCommand

% Send Data -----------------------------------------------
#def MClockHiDataLo 11111010b
#def MClockHiDataHi 11111110b
#def MClockLoDataLo 11110010b
#def MClockLoDataHi 11110110b

 ctmp = #.16
 while ( ctmp != #0 ) {
  porta = #MClockHiDataLo
  if ((lo)sword.0 == #1) {
   porta = #MClockHiDataHi
   porta = #MClockLoDataHi
  }
  porta = #MClockLoDataLo
  sword >>= #1
  ctmp --
 }

 porta = #MClockLoDataLo

 return

#lbl Tsdata  ;---------------------------------------------
 call TsSendCommand

% Send Data -----------------------------------------------
#def TClockHi 11110011b
#def TClockLo 11110010b

 ctmp = #.16
 while ( ctmp != #0 ) {
  porta = #TClockHi
  if ((lo)sword.0 == #1) {
   DataI/O = #0xFF
  } else {
   DataI/O = #0x00
  }
  porta = #TClockLo
  sword >>= #1
  ctmp --
 }

 DataI/O = #0

 return

#lbl Mrdata ;----------------------------------------------

 call MsSendCommand

#def MrClockHi 11111010b
#def MrClockLo 11110010b
#def MrMask    00000100b

#def PortInput 1
 page ( #1 )
 MPicData = #PortInput
 page ( #0 )

 mrword = #0

 ctmp = #.16
 while ( ctmp != #0 ) {
  porta = #MrClockHi
  status.cary = #0
  mrword >>= #1
  porta = #MrClockLo
  if ((W = porta & #MrMask) != #0) (hi)mrword.7 = #1
  ctmp --
 }

#def PortOutput 0
 page ( #1 )
 MPicData = #PortOutput
 page ( #0 )

 porta = #MrClockLo

return

#lbl Trdata ;----------------------------------------------

 call TsSendCommand

#def PortAllInput 0xFF
 page ( #1 )
 DataI/O = #PortAllInput
 page ( #0 )

 trword1 = #0
 trword2 = #0
 trword3 = #0
 trword4 = #0
 trword5 = #0
 trword6 = #0
 trword7 = #0
 trword8 = #0

#def TrClockHi 11110011b
#def TrClockLo 11110010b
#def TrMask    00000100b

#char rtmp

 ctmp = #.16
 while ( ctmp != #0 ) {
  porta = #TrClockHi
  status.cary = #0
  trword1 >>= #1
  trword2 >>= #1
  trword3 >>= #1
  trword4 >>= #1
  trword5 >>= #1
  trword6 >>= #1
  trword7 >>= #1
  trword8 >>= #1
  porta = #TrClockLo
  rtmp = portb
  if (rtmp.7 == #1) (hi)trword1.7 = #1
  if (rtmp.6 == #1) (hi)trword2.7 = #1
  if (rtmp.5 == #1) (hi)trword3.7 = #1
  if (rtmp.4 == #1) (hi)trword4.7 = #1
  if (rtmp.3 == #1) (hi)trword5.7 = #1
  if (rtmp.2 == #1) (hi)trword6.7 = #1
  if (rtmp.1 == #1) (hi)trword7.7 = #1
  if (rtmp.0 == #1) (hi)trword8.7 = #1
  ctmp --
 }

#def PortAllOutput 0x00
 page ( #1 )
 DataI/O = #PortAllOutput
 page ( #0 )

 DataI/O = #0

return

#lbl MsSendCommand ;---------------------------------------
#def ClockHi 1
#def ClockLo 0

 tmp = W

; #def MClockHiDataLo 11111010b
; #def MClockHiDataHi 11111110b
; #def MClockLoDataLo 11110010b
; #def MClockLoDataHi 11110110b

 ctmp = #6
 while ( ctmp != #0 ) {
  porta = #MClockHiDataLo
  if (tmp.0 == #1) {
   porta = #MClockHiDataHi
   porta = #MClockLoDataHi
  }
  porta = #MClockLoDataLo
  tmp >>= #1
  ctmp --
 }

 porta = #MClockLoDataLo

 nop
 nop

 return

#lbl TsSendCommand ;---------------------------------------

 tmp = W

; #def TClockHi 11110011b
; #def TClockLo 11110010b

#char ctmp
 ctmp = #6
 while ( ctmp != #0 ) {
  porta = #TClockHi
  if (tmp.0 == #1) {
   DataI/O = #0xFF
  } else {
   DataI/O = #0x00
  }
  porta = #TClockLo
  tmp >>= #1
  ctmp --
 }

 DataI/O = #0

 nop
 nop

 return

#lbl BeginProg ;-------------------------------------------

 W = #BEGINP
 call TsSendCommand
 return


#lbl Wait10msec ;------------------------------------------
#def WaitLoop .100
#char LoopCnt1
#char LoopCnt2

 LoopCnt1 =#WaitLoop
 while ( LoopCnt1 != #0) {
  LoopCnt2 = #.10
  while ( LoopCnt2 != #0) {
   LoopCnt2 --
   nop
   nop
   nop
   nop
  }
  LoopCnt1 --
 }
 return

#lbl TPicErace ;-------------------------------------------
 sword =  #0xFFFF  ;dummy data 
 W = #LCREG   ;Load Configuration 
 call Tsdata

 call IncAdr  ;2001h
 call IncAdr  ;2002h
 call IncAdr  ;2003h
 call IncAdr  ;2004h
 call IncAdr  ;2005h
 call IncAdr  ;2006h
 call IncAdr  ;2007h

 W = #00000001b
 call TsSendCommand

 W = #00000111b
 call TsSendCommand

 call BeginProg 

 call Wait10msec

 W = #00000001b
 call TsSendCommand

 W = #00000111b
 call TsSendCommand

 porta = #VppOFF
 nop
 nop
 nop
 porta = #VppON

 return

#lbl IncAdr ;----------------------------------------------
 W = #INCAD
 call TsSendCommand
 W = #INCAD
 call MsSendCommand
 return
